/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Framebuffer drivers header file for MicroWindows Video Drivers
 */
#ifndef FB_TYPE_VGA_PLANES
#define FB_TYPE_VGA_PLANES 4
#endif

typedef void *			FARADDR;
typedef unsigned char *		ADDR8;
typedef unsigned short *	ADDR16;
typedef unsigned long *		ADDR32;

typedef struct {
	int	 (*init)(void);
	void 	 (*drawpixel)(FARADDR addr, COORD x, COORD y, PIXELVAL c);
	PIXELVAL (*readpixel)(FARADDR addr, COORD x, COORD y);
	void 	 (*drawhorzline)(FARADDR addr, COORD x1, COORD x2, COORD y,
			PIXELVAL c);
	void	 (*drawvertline)(FARADDR addr, COORD x, COORD y1, COORD y2,
			PIXELVAL c);
	void	 (*blit)(FARADDR dstaddr, COORD destx, COORD desty, COORD w,
			COORD h, FARADDR srcaddr, COORD srcx, COORD srcy);
} FBENTRY;

/* entry points*/
int  fb_init(PSCREENDEVICE psd);
void fb_exit(void);
void fb_setpalette(int first, int count, RGBENTRY *palette);
int  failmsg(const char *format, ...);
#define fb_drawpixel(a,x,y,c)		(fbprocs->drawpixel)(a,x,y,c)
#define fb_readpixel(a,x,y)		(fbprocs->readpixel)(a,x,y)
#define fb_drawhorzline(a,x1,x2,y,c)	(fbprocs->drawhorzline)(a,x1,x2,y,c)
#define fb_drawvertline(a,x,y1,y2,c)	(fbprocs->drawvertline)(a,x,y1,y2,c)

/* global vars*/
extern int	XRES;
extern int	YRES;
extern int	NCOLORS;
extern int	LINELEN;	/* line length in pixels*/
extern FARADDR	FBADDR;
extern int	FBTYPE;
extern int	FBVISUAL;
extern int	drawing;
extern FBENTRY	*fbprocs;
extern FBENTRY	fbnull;

extern int 	gr_mode;	/* temp kluge*/
