/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Header file for EGA/VGA screen memory access
 * Added functions for Hercules access
 */

#if LINUX
#include <sys/io.h>		/* for outb def's, requires -O */
#define HAVEFARPTR	1
#define FAR
#endif

#if MSDOS
#define HAVEFARPTR	1	/* compiler has _far extension*/
#define FAR		_far
#endif


/* make far ptr*/
#define MK_FP(seg,ofs)	((FARADDR) \
			   (((unsigned long)(seg) << 16) | (unsigned)(ofs)))

#if HAVEFARPTR
/* far ptr access to screen*/
typedef unsigned char FAR *	FARADDR;

/* get byte at address*/
#define GETBYTE_FP(addr)	(*(FARADDR)(addr))

/* put byte at address*/
#define PUTBYTE_FP(addr,val)	((*(FARADDR)(addr)) = (val))

/* read-modify-write at address*/
#define RMW_FP(addr)		((*(FARADDR)(addr)) |= 1)

/* or byte at address*/
#define ORBYTE_FP(addr,val)	((*(FARADDR)(addr)) |= (val))

/* and byte at address*/
#define ANDBYTE_FP(addr,val)	((*(FARADDR)(addr)) &= (val))
#else

/* for bcc with no _far extension*/
typedef unsigned long	FARADDR;

/* get byte at address*/
extern unsigned char GETBYTE_FP(FARADDR);

/* put byte at address*/
extern void PUTBYTE_FP(FARADDR,unsigned char);

/* read-modify-write at address*/
extern void RMW_FP(FARADDR);

/* or byte at address*/
extern void ORBYTE_FP(FARADDR,unsigned char);

/* and byte at address*/
extern void ANDBYTE_FP(FARADDR,unsigned char);
#endif


#if MSDOS
#define outb(val,port)	outp(port,val)
#endif

#if ELKS
#define outb(val,port)	outportb(port,val)
#define outw(val,port)	outport(port,val)

extern int  inportb(int port);
extern void outportb(int port,unsigned char data);
extern void outport(int port,int data);
#endif


/* external routines*/
FARADDR		int10(int ax,int bx);
